/*
 * @Author: your name
 * @Date: 2021-10-21 20:51:17
 * @LastEditTime: 2022-03-09 19:13:51
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath:
 * /media/xnm/xnm/☆☆项目建档(禁删)☆☆/test/c++test/patterns/observer.cpp
 */
// 观察者模式是软件设计模式的一种。在此种模式中，一个目标对象管理所有相依于它的观察者对象，
// 并且在它本身的状态改变时主动发出通知。这通常透过呼叫各观察者所提供的方法来实现。
// 此种模式通常被用来实时事件处理系统。如动态调参？
// 观察者模式包括一下角色：
//可以用于ros的动态调参 参数更新后通知观察者来更新自己关新的数据
#pragma once
#include <future>
#include <iostream>
#include <vector>

#include "dynamic_config.h"

using namespace std;
namespace rm {
//抽象类 抽象观察者 被通知的角色
class Observer {
 public:
  Observer(){};
  virtual ~Observer(){};
  // 定义纯虚函数，规范接口
  virtual void update() = 0;
  virtual DynamicConfig *getDynamicConfig() = 0;
  virtual string getName() const = 0;
};

//抽象目标
class Subject {
 public:
  Subject(){};

  virtual ~Subject(){};

  //添加观察者
  void addObserver(Observer *observer) { m_observers.push_back(observer); }

  //删除观察者
  void deleteObserver(Observer *observer) {
    for (vector<Observer *>::iterator iter = m_observers.begin();
         iter != m_observers.end(); iter++) {
      if (*iter == observer) {
        m_observers.erase(iter);
        return;
      }
    }
  }

  //通知观察者
  void notifyObservers() {
    if (!getChanged()) return;
    for (vector<Observer *>::iterator iter = m_observers.begin();
         iter != m_observers.end(); iter++) {
      (*iter)->update();
    }
    setChanged(false);
  }

  virtual bool Start() = 0;
  // virtual CtApRoadModel::RMConfig getConfigs() const = 0;
  virtual void setChanged(bool flag) = 0;
  virtual bool getChanged() const = 0;

 private:
  vector<Observer *> m_observers;
};

}  // namespace rm